#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const env_vars_js_1 = require("./env-vars.js");
(0, tstest_1.test)('getNumberEnv() no env', async (t) => {
    const DEFAULT_VALUE = 42;
    const SET_VALUE = 17;
    const KEY = 'TEST_NUMBER';
    const FIXTURE = [
        {
            env: {},
            value: DEFAULT_VALUE,
        },
        {
            env: {
                [KEY]: String(SET_VALUE),
            },
            value: SET_VALUE,
        },
        {
            env: {
                [KEY]: `xxx${SET_VALUE}xxx`,
            },
            value: DEFAULT_VALUE,
        },
    ];
    for (const { env, value } of FIXTURE) {
        t.equal((0, env_vars_js_1.getNumberEnv)(env)(KEY, DEFAULT_VALUE), value, `should get ${value} from "${JSON.stringify(env)}"`);
    }
});
//# sourceMappingURL=env-vars.spec.js.map