#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
// @ts-check
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const puppet_test_js_1 = require("./fixtures/puppet-test/puppet-test.js");
(0, tstest_1.test)('login testing', async (t) => {
    const puppet = new puppet_test_js_1.PuppetTest();
    const USER_ID = 'test-user';
    let userFromEvent = null;
    const future = new Promise(resolve => puppet.on('login', user => {
        userFromEvent = user.contactId;
        resolve();
    }));
    await puppet.start();
    puppet.login(USER_ID);
    await future;
    t.same(userFromEvent, USER_ID, `should get login event with ${USER_ID}`);
    await puppet.stop();
    t.notOk(puppet.isLoggedIn, 'puppet should not be logged in after stop');
});
//# sourceMappingURL=login.spec.js.map